searchData={"items":[{"type":"behaviour","title":"RedisMutex","doc":"An Elixir library for using Redis locks.","ref":"RedisMutex.html"},{"type":"function","title":"RedisMutex.child_spec/1","doc":"The specification for starting a connection with Redis. Can include any of the\n`connection_options`.","ref":"RedisMutex.html#child_spec/1"},{"type":"callback","title":"RedisMutex.child_spec/1","doc":"","ref":"RedisMutex.html#c:child_spec/1"},{"type":"function","title":"RedisMutex.start_link/1","doc":"Starts a process as part of a supervision tree.","ref":"RedisMutex.html#start_link/1"},{"type":"callback","title":"RedisMutex.start_link/1","doc":"","ref":"RedisMutex.html#c:start_link/1"},{"type":"callback","title":"RedisMutex.with_lock/2","doc":"","ref":"RedisMutex.html#c:with_lock/2"},{"type":"function","title":"RedisMutex.with_lock/3","doc":"Provides a mutex for performing a function.\n\nThe lock is defined by the key argument. When the key is already taken, the function will not be\nperformed. When the key is not already in use, the function argument is run.\n\nThe key should be unique to the operation being performed.\n\nThe function provided should be a zero-arity function.","ref":"RedisMutex.html#with_lock/3"},{"type":"function","title":"Options - RedisMutex.with_lock/3","doc":"* `:name` - the name of the Redis connection to use when performing the lock.\n    Defaults to `RedisMutex`. If you have provided a different name for the connection\n    during initiation of the connection, you must provide that name in the options for\n    `with_lock/3`.\n\n  * `:timeout` - how long `RedisMutex` will try before abandoning the attempt to gain the\n  lock. Timeout is in milliseconds. Defaults to 4_000.\n\n  * `:expiry` - how long the lock will be held before expiring. Expiry is in milliseconds.\n  Defaults to 2_000.","ref":"RedisMutex.html#with_lock/3-options"},{"type":"callback","title":"RedisMutex.with_lock/3","doc":"","ref":"RedisMutex.html#c:with_lock/3"},{"type":"type","title":"RedisMutex.connection_options/0","doc":"Options for connecting to Redis.","ref":"RedisMutex.html#t:connection_options/0"},{"type":"type","title":"Options - RedisMutex.connection_options/0","doc":"* `:name` - the name to use for a Redis connection. When not provided, the connection name\n    defaults to `RedisMutex`. If you have provided a different name for the connection\n    during initiation of the connection, you must provide that name in the options for\n    `with_lock/3`.\n\n  * `:redis_url` - The URL to use connecting to Redis. When this is provided, other options are\n    not needed. When `:redis_url` is provided, the only other options honored are `:name`\n    and `:sync_connect`.\n\n  When `:redis_url` is not provided, other connection options (like `:host` and `:port`) must be\n  provided.","ref":"RedisMutex.html#t:connection_options/0-options"},{"type":"type","title":"RedisMutex.lock_opts/0","doc":"","ref":"RedisMutex.html#t:lock_opts/0"},{"type":"type","title":"RedisMutex.name/0","doc":"","ref":"RedisMutex.html#t:name/0"},{"type":"module","title":"RedisMutex.Lock","doc":"Defines the lock for RedisMutex.","ref":"RedisMutex.Lock.html"},{"type":"function","title":"RedisMutex.Lock.with_lock/3","doc":"","ref":"RedisMutex.Lock.html#with_lock/3"},{"type":"exception","title":"RedisMutex.Error","doc":"","ref":"RedisMutex.Error.html"},{"type":"extras","title":"Readme","doc":"# RedisMutex\n\n[![Build Status](https://github.com/podium/redis_mutex/actions/workflows/ci.yml/badge.svg)](https://github.com/podium/redis_mutex/actions/workflows/ci.yml) [![Hex.pm](https://img.shields.io/hexpm/v/redis_mutex.svg)](https://hex.pm/packages/redis_mutex) [![Documentation](https://img.shields.io/badge/documentation-gray)](https://hexdocs.pm/redis_mutex)\n[![Total Download](https://img.shields.io/hexpm/dt/redis_mutex.svg)](https://hex.pm/packages/redis_mutex)\n[![License](https://img.shields.io/hexpm/l/redis_mutex.svg)](https://github.com/podium/redis_mutex/blob/master/LICENSE.md)\n\nRedisMutex is a library for creating a Redis lock for a single Redis instance.","ref":"readme.html"},{"type":"extras","title":"Installation - Readme","doc":"The package can be installed by adding `redis_mutex`\nto your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:redis_mutex, \"~> 1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Upgrading from version 0.X to version 1.X - Readme","doc":"Version 1.0.0 of `RedisMutex` changes how `RedisMutex` is started and how `with_lock` is used. Key changes include:\n\n1. `RedisMutex` no longer runs as its own application.\n   1. If you need or want to set up a Redix connection specifically for `RedisMutex`, it must be added to your application's\n      supervision tree.\n   2. If you want to re-use an existing Redis connection via Redix, it does not need adding to your application's\n      supervision tree.\n2. Using `RedisMutex`'s `with_lock` is no longer done via `use RedisMutex`. Instead, your application must call\n   the function `RedisMutex.with_lock/3`.\n3. The code you want to execute in `RedisMutex.with_lock/3` is passed in a zero-arity function instead of in a `do`\n   block.\n4. Timeout and expiry options for `RedisMutex.with_lock/3` are optionally provided in a keyword list as the last\n   argument to `RedisMutex.with_lock/3`.\n5. Callbacks are defined for `RedisMutex`'s functions to allow for doubles to be used in testing.\n\nIn order to upgrade to version 1.X, you will need to:\n1. Add `RedisMutex` to your application's supervision tree unless you are using an existing Redis connection via Redix.\n2. Remove use of `use RedisMutex` in favor of `RedisMutex.with_lock/3`.\n3. Replace the `do` block with a zero-arity function in your calls to `RedisMutex.with_lock/3`.\n4. Move any timeout or expiry arguments into a keyword list as the final argument to `RedisMutex.with_lock/3`.\n5. If you are not running Redis when you run your unit tests, update your test suite to use a double\n   that handles `RedisMutex`'s updated functions.","ref":"readme.html#upgrading-from-version-0-x-to-version-1-x"},{"type":"extras","title":"What is involved in updating the use of `with_lock`? - Readme","doc":"Here's a quick example of the changes that need to be made to how you use `with_lock`.\n\n#### Using `with_lock` in version 0.X\n\n```elixir\ndefmodule PossumLodge do\n  use RedisMutex\n\n  def get_oauth do\n    with_lock(\"my_key\") do\n      \"Quando omni flunkus moritati\"\n    end\n  end\nend\n```\n\n#### Using `with_lock` in version 1.X\n\n```elixir\ndefmodule PossumLodge do\n\n  def get_oauth do\n    RedisMutex.with_lock(\"my_key\", fn ->\n      \"Quando omni flunkus moritati\"\n    end)\n  end\nend\n```\n\nPlease see the [Usage](#usage) section for more details and examples.","ref":"readme.html#what-is-involved-in-updating-the-use-of-with_lock"},{"type":"extras","title":"Usage - Readme","doc":"`RedisMutex` offers the user flexibility in how it is used.\n\nIf you already have a named connection to Redis and want to re-use that, using `RedisMutex` is dead simple.\n\nIf you need to start a named connection to Redis for a mutex, you can do so via `RedisMutex`.`RedisMutex` offers\na default connection name when starting your connection to Redis. This is the simplest way to use `RedisMutex`,\nand it is the default.\n\nIf you want to customize the name used for that connection, you can specify a name to use for the connection.","ref":"readme.html#usage"},{"type":"extras","title":"Using an existing named connection to Redis - Readme","doc":"In order to use an existing connection, you can simply pass the name of that connection as an option to\n`RedisMutex.with_lock/3`\n\n```elixir\ndefmodule PossumLodge do\n  @redis_connection_opts [name: :my_existing_redis_connection]\n\n  def get_oauth do\n    RedisMutex.with_lock(\n      \"my_key\",\n      fn -> \"Quando omni flunkus moritati\" end,\n      @redis_connection_opts\n    )\n  end\nend\n```","ref":"readme.html#using-an-existing-named-connection-to-redis"},{"type":"extras","title":"Starting a new connection to Redis - Readme","doc":"If you don't have an existing connection that you want to re-use, and you want to start a connection for `RedisMutex`,\nyou need to set options in your configuration and add `RedisMutex` to your application's supervision tree.\n\nIf you have a named connection to Redis that you want to re-use, you do not need to add `RedisMutex`\nto your application's supervision tree.\n\n#### Using `RedisMutex`'s defaults\n\nBy default, `RedisMutex` will use `:redis_mutex_connection` as the name for setting up a connection to Redis.\n\n#### Adding `RedisMutex` to your application's supervision tree with `RedisMutex`'s defaults\n\nSet the `options` in your for `RedisMutex` in your supervision tree. The options can be a `redis_url` or a set of \noptions for Redis. See `RedisMutex.start_options` for details.\n\nBy default, `RedisMutex` will use `:redis_mutex_connection` as the name for setting up a connection to Redis.\n\n##### Example with the default name and a `redis_url`\n\n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [{RedisMutex, redis_url: System.get_env(\"REDIS_URL\")}]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```\n##### Example with the default name and other connection options\n\n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [{RedisMutex, host: System.get_env(\"REDIS_URL\"), port: System.get_env(\"REDIS_PORT\")}]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```\n\n#### Using a custom connection name\n\nIf you want to start a connection with a name other than `RedisMutex`, you should specify the name you\nwant to use when adding `RedisMutex` to your application's supervision tree. You will also need to provide this \nname as an option to the lock function when using `RedisMutex`.\n\n#### Adding `RedisMutex` to your application's supervision tree with a custom connection name\n\nIn order to specify the connection name, include it as an option when adding `RedisMutex` to your\napplication's supervision tree.\n\n##### Example with a name specified and a `redis_url`\n\n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [\n      {RedisMutex, \n        name: MyApp.Mutex, \n        redis_url: System.get_env(\"REDIS_URL\", \"redis://localhost:6379\")\n      }\n    ]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```\n##### Example with a name specified and other connection options\n\n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [\n      {RedisMutex, \n        name: MyApp.RedisMutex,\n        host: System.get_env(\"REDIS_HOST\", \"localhost\"), \n        port: System.get_env(\"REDIS_PORT\", 6379)\n      }\n    ]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```","ref":"readme.html#starting-a-new-connection-to-redis"},{"type":"extras","title":"Wrapping `RedisMutex` - Readme","doc":"If you are using a custom connection name and want to simplify the use of `RedisMutex`, you can\nwrite a wrapper module for `RedisMutex` and add that module to your application's supervision tree.\n\n#### Sample wrapper module\n```elixir\ndefmodule MyApp.Mutex do\n\n  @redis_mutex Application.compile_env(:my_app, :redis_mutex, RedisMutex)\n  \n  def child_spec(opts) do\n    child_spec_opts = Keyword.merge(opts, name: MyApp.Mutex)\n    @redis_mutex.child_spec(child_spec_opts)\n  end\n  \n  def start_link(start_options) do\n    @redis_mutex.start_link(start_options)\n  end\n  \n  def with_lock(key, opts, fun) do\n    lock_options = Keyword.merge(opts, name: MyApp.Mutex)\n    @redis_mutex.with_lock(key, fun, lock_options)\n  end\nend\n```\n\n#### Adding the wrapper module to the supervision tree \n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [\n      {MyApp.Mutex,\n      redis_url: System.get_env(\"REDIS_URL\")\n      }\n    ]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```","ref":"readme.html#wrapping-redismutex"},{"type":"extras","title":"Using `RedisMutex` - Readme","doc":"Call `RedisMutex`'s `with_lock/3` function to lock critical parts of your code. `with_lock/3` must be\nprovided with a `key` argument and a zero-arity function argument to call. This function will be called\nif and when the lock is acquired.\n\n```elixir\ndefmodule PossumLodge do\n\n  @redis_mutex Application.compile_env(:my_app, :redis_mutex, RedisMutex)\n  \n  def get_oauth do\n    @redis_mutex.with_lock(\"my_key\", fn ->\n      \"Quando omni flunkus moritati\"\n    end)\n  end\nend\n```\n\n`with_lock/3` also allows setting options, including a name for the connection, a timeout and an\nexpiry, both in milliseconds. If you have specified a custom connection name or are re-using an\nexisting named connection to redis, the name of that connection must be included in the options\nwhen calling `with_lock/3`.\n\n```elixir\ndefmodule PossumLodge do\n\n  @redis_mutex Application.compile_env(:my_app, :redis_mutex, RedisMutex)\n  @mutex_options [name: MyApp.Mutex, timeout: 500, expiry: 1_000]\n  \n  def get_oauth do\n    @redis_mutex.with_lock(\n      \"my_key\", \n      fn -> \"Quando omni flunkus moritati\" end,\n      @mutex_options\n      )\n  end\nend\n```","ref":"readme.html#using-redismutex"},{"type":"extras","title":"Testing your application with `RedisMutex` - Readme","doc":"","ref":"readme.html#testing-your-application-with-redismutex"},{"type":"extras","title":"Testing your application with Redis running - Readme","doc":"If you are running Redis when you are running your test suite, simply having the `redis_mutex` config set and \nrunning the default command works:\n\n```\nmix test\n```","ref":"readme.html#testing-your-application-with-redis-running"},{"type":"extras","title":"Testing your application without an instance of Redis running - Readme","doc":"If you want to test your application without an instance of Redis running, you will need to define a double for\n`RedisMutex`. `RedisMutex` defines callbacks for `child_spec/1`, `start_link/1`, `with_lock/2` and `with_lock/3`.\n\n#### Define a mock for `RedisMutex`\n\nIf you are using `Mox`, you can define the mock along with your other mocks.\n\n```\nMox.defmock(RedisMutexMock, for: RedisMutex)\n```","ref":"readme.html#testing-your-application-without-an-instance-of-redis-running"},{"type":"extras","title":"CHANGELOG","doc":"# CHANGELOG","ref":"changelog.html"},{"type":"extras","title":"1.1.0 (2024-10-01) - CHANGELOG","doc":"* Remove support for Elixir 1.13. Minimum is Elixir 1.14","ref":"changelog.html#1-1-0-2024-10-01"},{"type":"extras","title":"1.0.0 (2024-02-12) - CHANGELOG","doc":"","ref":"changelog.html#1-0-0-2024-02-12"},{"type":"extras","title":"Changed - CHANGELOG","doc":"**Breaking changes**\n- `RedisMutex` no longer starts as its own application. Instead, it can re-use an existing Redis connection\n  or be started in your application's supervision tree. Here is an example of starting it in an application's\n  supervision tree:\n```elixir\n  @impl Application\n  def start(_type, _args) do\n    children = other_children() ++ [{RedisMutex, redis_url: System.get_env(\"REDIS_URL\")}]\n    Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n  end\n```\n  Please see the README for more details.\n- `use RedisMutex` replaced in favor of calling `RedisMutex.with_lock/3` directly\n- `with_lock` changed to take a function argument instead of a do block to perform\n- `with_lock` changed to take a keyword list of options instead of optional `timeout` and `expiry` arguments","ref":"changelog.html#changed"},{"type":"extras","title":"0.6.0 (2023-11-08) - CHANGELOG","doc":"","ref":"changelog.html#0-6-0-2023-11-08"},{"type":"extras","title":"Changed - CHANGELOG","doc":"- support for Elixir 1.15. Bump some package dependencies\n- change to use Uniq lib rather than the unmaintained elixir_uuid","ref":"changelog.html#changed"},{"type":"extras","title":"0.5.0 (2023-08-16) - CHANGELOG","doc":"","ref":"changelog.html#0-5-0-2023-08-16"},{"type":"extras","title":"Changed - CHANGELOG","doc":"* Support custom redix opts by @brentjanderson (#23)\n* Updates some of the dependencies","ref":"changelog.html#changed"},{"type":"extras","title":"0.4.0 (2022-11-22) - CHANGELOG","doc":"","ref":"changelog.html#0-4-0-2022-11-22"},{"type":"extras","title":"Changed - CHANGELOG","doc":"* Use Redix instead of ExRedis as the adapter\n* Bump Elixir version to 1.11\n* Retool the internals of the library to use modern Elixir conventions\n* Updates to the test suite so it can run against live redis in test","ref":"changelog.html#changed"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}